<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Structure</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="structure">Structure </a></h1><hr/>
<p>Sections:</p>
<ul>
<li><a class="el" href="structure.html#magpar_diag">Diagrams</a></li>
<li><a class="el" href="structure.html#magpar_main">Main program</a></li>
<li><a class="el" href="structure.html#magpar_init">Initialization</a><ul>
<li><a class="el" href="structure.html#magpar_init_ser">Serial part</a></li>
<li><a class="el" href="structure.html#magpar_init_par">Parallel part</a></li>
</ul>
</li>
<li><a class="el" href="structure.html#magpar_solve">Solution loop</a><ul>
<li><a class="el" href="structure.html#magpar_solve_field">Field and energy calculation</a></li>
<li><a class="el" href="structure.html#magpar_solve_tao">Energy minimization</a></li>
<li><a class="el" href="structure.html#magpar_solve_llg">LLG time integration</a></li>
</ul>
</li>
<li><a class="el" href="structure.html#magpar_final">Finalizing</a></li>
<li><a class="el" href="structure.html#magpar_gdata">GridData: Global data structure</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="magpar_diag">
Diagrams</a></h2>
<p>magpar is based on PETSc, which provides the required parallel data structures, linear algebra operations and solvers. PETSc in turn is based on MPI for message passing and the BLAS and LAPACK libraries (non-parallel) for linear algebra.</p>
<div align="center">
<img src="prgstruct_petsc.eps.gif" alt="prgstruct_petsc.eps.gif"/>
<p><strong>PETSc structure</strong></p></div>
<p> TAO and PVODE are used for energy minimization and dynamic time integration. Mesh partitioning, data compression, and graphics output are done by some more (non-parallel) libraries, Metis, zlib, and libpng, respectively.</p>
<div align="center">
<img src="prgstruct_rest.eps.gif" alt="prgstruct_rest.eps.gif"/>
<p><strong>Additional libraries</strong></p></div>
<p> The following figure gives a coarse flow chart of magpar (not quite up to date).</p>
<div align="center">
<img src="flowall.gif" alt="flowall.gif"/>
<p><strong>magpar flow chart</strong></p></div>
<p> More detailed information about the libraries can be found on the page about <a class="el" href="required.html">Required Software</a>.</p>
<hr/>
<h2><a class="anchor" id="magpar_main">
Main program</a></h2>
<p><a class="el" href="main_8c.html">main.c</a></p>
<p><a class="el" href="main_8c.html#a7a29781a20c5dd4153c3c1cecf0ff328">main.c::main</a></p>
<ul>
<li>PetscInitialize</li>
<li>TAOInitialize</li>
<li><a class="el" href="serinit_8c.html#ae4c8f3120a177cfe3ce6929927865a94">serinit.c::SerInit</a></li>
<li><a class="el" href="parinit_8c.html#aab78598aa0d3ece1097d988997f0aea3">parinit.c::ParInit</a></li>
<li><a class="el" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">main.c::Solve</a></li>
<li>PetscFinalize</li>
</ul>
<hr/>
<h2><a class="anchor" id="magpar_init">
Initialization</a></h2>
<h3><a class="anchor" id="magpar_init_ser">
Serial part</a></h3>
<p><a class="el" href="serinit_8c.html#ae4c8f3120a177cfe3ce6929927865a94">serinit.c::SerInit</a></p>
<div class="fragment"><pre class="fragment">  ierr = <a class="code" href="init_8h.html#a25ee3bfa58a704838a8bc6309f083f5c">InitInfo</a>();CHKERRQ(ierr);
  ierr = <a class="code" href="magpario_8h.html#a365fc802eafb717ba4c584655d1e9b64">ReadMesh</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="magpario_8h.html#a59544353738dfce0bdce48409d9b3c8b">ReadKrn</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#a155bbdd0e9cc1c9194b91b08ca8162ac">ModifyPropSer</a>(gdata);CHKERRQ(ierr);
  ierr = ModifyPropSerGrains(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#accaf6541cd8225c7be69bdf5f6ac44d5">MagInit</a>(gdata);CHKERRQ(ierr);
  ierr = Hext_in1_Init(gdata);CHKERRQ(ierr);
  ierr = Hext_in2_Init(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="filterelements_8c.html#a49c370a78a03718555d9d871ef6e11ee">FilterElements</a>(&amp;gdata-&gt;n_ele,&amp;gdata-&gt;elevert,&amp;gdata-&gt;eleprop,gdata-&gt;propdat);CHKERRQ(ierr);
  ierr = MeshMirror(&amp;gdata-&gt;n_vert,&amp;gdata-&gt;n_ele,&amp;gdata-&gt;vertxyz,&amp;gdata-&gt;elevert,&amp;gdata-&gt;eleprop);CHKERRQ(ierr);
  ierr = <a class="code" href="filternodes_8c.html#ab1da8fc65b9539386e71fb8601e36deb">FilterNodes</a>(&amp;gdata-&gt;n_vert,&amp;gdata-&gt;n_ele,&amp;gdata-&gt;vertxyz,gdata-&gt;elevert,&amp;gdata-&gt;M,&amp;gdata-&gt;VH1,&amp;gdata-&gt;VH2);CHKERRQ(ierr);
  ierr = <a class="code" href="filterelements_8c.html#a49c370a78a03718555d9d871ef6e11ee">FilterElements</a>(&amp;gdata-&gt;n_ele,&amp;gdata-&gt;elevert,&amp;gdata-&gt;eleprop,gdata-&gt;propdat);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#a445ec9c1079f67af589544afbcea155f">RegularRefinement</a>(gdata);CHKERRQ(ierr);
  ierr = DecoupleGrains(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#a37fbeb81912fa6f3e4bcc7e3dd71bc62">Reorder</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="facnb_8c.html#ab880c52c1f93378088ef1e53763aa916">FacNB</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#a031e1284b34dfcb64f029f9bd16545ce">VertProp</a>(gdata);CHKERRQ(ierr);
  ierr = DataPartitionSurfSer(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="distortmesh_8c.html#a07f75fef1770fdca0f1cf8ea3369c8b2">DistortMesh</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#aac2a4c334ae5c2baef33867114fe8006">DataMoveData</a>(gdata);CHKERRQ(ierr);
</pre></div><h3><a class="anchor" id="magpar_init_par">
Parallel part</a></h3>
<p><a class="el" href="parinit_8c.html#aab78598aa0d3ece1097d988997f0aea3">parinit.c::ParInit</a></p>
<div class="fragment"><pre class="fragment">  ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-mode&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;gdata-&gt;mode,&amp;flg);CHKERRQ(ierr);
  ierr = <a class="code" href="init_8h.html#a5b18b26ca79926b582bf94e21e5f531b">ModifyPropPar</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="elevertvol_8c.html#a2103238be825fa27dce52bbc795d532d">EleVertVol</a>(gdata);CHKERRQ(ierr);
  ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-ts_init_time&quot;</span>,&amp;tstart,&amp;flg);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">myTSCreatePVode</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="checkiterationllg_8c.html#a5433821a82b3ad3af34bb43677541a33">CheckIterationLLG</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">myTSCreateEmini</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="magpario_8h.html#afcfe52b023f7bd7762b109bea3096cfc">WriteFEMAVS</a>(gdata);CHKERRQ(ierr);
      ierr = <a class="code" href="checkiterationemini_8c.html#a1c9f3282235f811af60323611535e99b">CheckIterationEmini</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="destroyinit_8c.html#a1b4144014467c57b1ce5f003775cd266">DataDestroyInit</a>(gdata);CHKERRQ(ierr);
</pre></div><hr/>
<h2><a class="anchor" id="magpar_solve">
Solution loop</a></h2>
<p><a class="el" href="main_8c.html#af91d94707b6b88920418dfb69be0e106">main.c::Solve</a> </p>
<div class="fragment"><pre class="fragment"><span class="preprocessor"># pseudocode</span>
<span class="preprocessor"></span><span class="keywordflow">while</span> (<a class="code" href="main_8c.html#ae4f2eb4a1c11c65d9a480b992675dcf9">keepsolving</a>)
<span class="keywordflow">switch</span>: -mode
</pre></div><p> (see <a class="el" href="allopttxt.html">allopt.txt</a>) <br/>
 <a class="el" href="main_8c.html#ae4f2eb4a1c11c65d9a480b992675dcf9">main.c::keepsolving</a>: check exit conditions, write <a class="el" href="output.html#project_9999">project.9999.*</a> (checkpoint) files, check after each iteration</p>
<h3><a class="anchor" id="magpar_solve_field">
Field and energy calculation</a></h3>
<p><a class="el" href="htot_8c.html#ab9d30ce64708afeca163280386deb654">htot.c::Htot</a> </p>
<div class="fragment"><pre class="fragment">  ierr = <a class="code" href="field_8h.html#ace2ad4bc212a40902a58d3bfdaa0518a">Hcubic</a>(gdata,VHtotsum);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#a8e779a08a066fda9160df1a7e5102a58">Hdemag</a>(gdata,VHtotsum);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#a97e3d5671797656fb91afa5e61778e74">Helastic</a>(gdata,VHtotsum);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#ab3c152ad4a30f46fd55fff971a53d2ae">Hexchani</a>(gdata,VHtotsum);CHKERRQ(ierr);
  ierr = <a class="code" href="field_8h.html#aeaf153862ea87b88e30bee559bf1d481">Hexternal</a>(gdata,VHtotsum);CHKERRQ(ierr);
  [...]
</pre></div><p> accordingly for energy (note that in general E!=M.H !)</p>
<h3><a class="anchor" id="magpar_solve_tao">
Energy minimization</a></h3>
<p>Initialization: <a class="el" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">eminisolve.c::myTSCreateEmini</a> <br/>
 Solution: <a class="el" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">eminisolve.c::EminiSolve</a> : call TaoSolve to find energ minimum</p>
<h3><a class="anchor" id="magpar_solve_llg">
LLG time integration</a></h3>
<p>Initialization: <a class="el" href="mytscreatepvode_8c.html#a9671ea286af405e584ae7468a0ce15b3">mytscreatepvode.c::myTSCreatePVode</a> <br/>
 Solution: <a class="el" href="mytssteppvode_8c.html#a61c49a5366b0ae16513998a657704e37">mytssteppvode.c::myTSStepPVode</a> : call CVode to take on time step <br/>
 LLG right hand side: <a class="el" href="rhsfunction_8c.html#a5e964b5572e1640d9a793c353f6a28f6">rhsfunction.c::RHSfunction</a> calls calc_dMdt::calc_dMdt.c <br/>
 Preconditioning: <a class="el" href="precond_8c.html#a8cdc0d7af89d96e9d57fc6c0f791331f">precond.c::Precond</a>, Jacobian: <a class="el" href="myllgjacobian_8c.html#a35010647607c93a40bdab3e86041714f">myllgjacobian.c::myLLGJacobian</a></p>
<hr/>
<h2><a class="anchor" id="magpar_final">
Finalizing</a></h2>
<p>Write final entry in log files and final set of output files </p>
<div class="fragment"><pre class="fragment">  ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
  ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
  PetscFinalize();
</pre></div><p> At the end of the program we do not clean up carefully (i.e. we do not destroy all data structures or free dynamically allocated memory) because the OS will do it for us anyway.</p>
<hr/>
<h2><a class="anchor" id="magpar_gdata">
GridData: Global data structure</a></h2>
<p><a class="el" href="structGridData.html">GridData</a></p>
<p>(see HTML documentation) </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

